/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.150 Revision 1.165
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.150 2010/08/21 19:39:52 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.165 2011/08/29 01:28:10 vapier Exp $
4 4
5# @ECLASS: mysql.eclass 5# @ECLASS: mysql.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
8# Maintainers: MySQL Team <mysql-bugs@gentoo.org> 7# MySQL Team <mysql-bugs@gentoo.org>
9# - Luca Longinotti <chtekk@gentoo.org> 8# Luca Longinotti <chtekk@gentoo.org>
10# - Robin H. Johnson <robbat2@gentoo.org> 9# Robin H. Johnson <robbat2@gentoo.org>
10# @AUTHOR:
11# Francesco Riosa (Retired) <vivo@gentoo.org>
11# @BLURB: This eclass provides most of the functions for mysql ebuilds 12# @BLURB: This eclass provides most of the functions for mysql ebuilds
12# @DESCRIPTION: 13# @DESCRIPTION:
13# The mysql.eclass provides almost all the code to build the mysql ebuilds 14# The mysql.eclass provides almost all the code to build the mysql ebuilds
14# including the src_unpack, src_prepare, src_configure, src_compile, 15# including the src_unpack, src_prepare, src_configure, src_compile,
15# scr_install, pkg_preinst, pkg_postinst, pkg_config and pkg_postrm 16# scr_install, pkg_preinst, pkg_postinst, pkg_config and pkg_postrm
143 144
144RDEPEND="${DEPEND} 145RDEPEND="${DEPEND}
145 !minimal? ( dev-db/mysql-init-scripts ) 146 !minimal? ( dev-db/mysql-init-scripts )
146 selinux? ( sec-policy/selinux-mysql )" 147 selinux? ( sec-policy/selinux-mysql )"
147 148
149DEPEND="${DEPEND}
150 virtual/yacc"
151
152if [ "${EAPI:-0}" = "2" ]; then
153 DEPEND="${DEPEND} static? ( || ( sys-libs/ncurses[static-libs] <=sys-libs/ncurses-5.7-r3 ) )"
154fi
155
148# compile-time-only 156# compile-time-only
149mysql_version_is_at_least "5.1" \ 157mysql_version_is_at_least "5.1" \
150|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )" 158|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
151 159
152# compile-time-only 160# compile-time-only
153mysql_version_is_at_least "5.1.12" \ 161mysql_version_is_at_least "5.1.12" \
154&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3" 162&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3"
163
164[[ "${PN}" == "mariadb" ]] \
165&& mysql_version_is_at_least "5.2" \
166&& DEPEND="${DEPEND} oqgraph? ( >=dev-libs/boost-1.40.0 )"
167#SphinxSE is included but is not available in 5.2.4 due to a missing plug.in file
168# sphinx? ( app-misc/sphinx )"
155 169
156# dev-perl/DBD-mysql is needed by some scripts installed by MySQL 170# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
157PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 171PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
158 172
159# For other stuff to bring us in 173# For other stuff to bring us in
164 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}" 178 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}"
165 if [ "${PN}" == "mariadb" ]; then 179 if [ "${PN}" == "mariadb" ]; then
166 MARIA_FULL_PV="$(replace_version_separator 3 '-' ${PV})" 180 MARIA_FULL_PV="$(replace_version_separator 3 '-' ${PV})"
167 MARIA_FULL_P="${PN}-${MARIA_FULL_PV}" 181 MARIA_FULL_P="${PN}-${MARIA_FULL_PV}"
168 SERVER_URI=" 182 SERVER_URI="
183 http://ftp.osuosl.org/pub/mariadb/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
169 http://ftp.rediris.es/mirror/MariaDB/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz 184 http://ftp.rediris.es/mirror/MariaDB/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
170 http://maria.llarian.net/download/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz 185 http://maria.llarian.net/download/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
171 http://launchpad.net/maria/${MYSQL_PV_MAJOR}/ongoing/+download/${MARIA_FULL_P}.tar.gz 186 http://launchpad.net/maria/${MYSQL_PV_MAJOR}/ongoing/+download/${MARIA_FULL_P}.tar.gz
187 http://mirrors.fe.up.pt/pub/${PN}/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
188 http://ftp-stud.hs-esslingen.de/pub/Mirrors/${PN}/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
172 " 189 "
173 # The community and cluster builds are on the mirrors 190 # The community and cluster builds are on the mirrors
174 elif [[ "${MYSQL_COMMUNITY_FEATURES}" == "1" || ${PN} == "mysql-cluster" ]] ; then 191 elif [[ "${MYSQL_COMMUNITY_FEATURES}" == "1" || ${PN} == "mysql-cluster" ]] ; then
175 if [[ "${PN}" == "mysql-cluster" ]] ; then 192 if [[ "${PN}" == "mysql-cluster" ]] ; then
176 URI_DIR="MySQL-Cluster" 193 URI_DIR="MySQL-Cluster"
236&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling" 253&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling"
237 254
238[[ "${PN}" == "mariadb" ]] \ 255[[ "${PN}" == "mariadb" ]] \
239&& IUSE="${IUSE} libevent" 256&& IUSE="${IUSE} libevent"
240 257
258[[ "${PN}" == "mariadb" ]] \
259&& mysql_version_is_at_least "5.2" \
260&& IUSE="${IUSE} oqgraph"
261#SphinxSE is included but is not available in 5.2.4 due to a missing plug.in file
262#&& IUSE="${IUSE} oqgraph sphinx"
263
241# MariaDB has integrated PBXT 264# MariaDB has integrated PBXT
242# PBXT_VERSION means that we have a PBXT patch for this PV 265# PBXT_VERSION means that we have a PBXT patch for this PV
243# PBXT was only introduced after 5.1.12 266# PBXT was only introduced after 5.1.12
244pbxt_patch_available() { 267pbxt_patch_available() {
245 [[ "${PN}" != "mariadb" ]] \ 268 [[ "${PN}" != "mariadb" ]] \
298mysql_disable_test() { 321mysql_disable_test() {
299 local rawtestname testname testsuite reason mysql_disable_file 322 local rawtestname testname testsuite reason mysql_disable_file
300 rawtestname="${1}" ; shift 323 rawtestname="${1}" ; shift
301 reason="${@}" 324 reason="${@}"
302 ewarn "test '${rawtestname}' disabled: '${reason}'" 325 ewarn "test '${rawtestname}' disabled: '${reason}'"
303 326
304 testsuite="${rawtestname/.*}" 327 testsuite="${rawtestname/.*}"
305 testname="${rawtestname/*.}" 328 testname="${rawtestname/*.}"
306 mysql_disable_file="${S}/mysql-test/t/disabled.def" 329 mysql_disable_file="${S}/mysql-test/t/disabled.def"
307 #einfo "rawtestname=${rawtestname} testname=${testname} testsuite=${testsuite}" 330 #einfo "rawtestname=${rawtestname} testname=${testname} testsuite=${testsuite}"
308 echo ${testname} : ${reason} >> "${mysql_disable_file}" 331 echo ${testname} : ${reason} >> "${mysql_disable_file}"
568 myconf="${myconf} --with-readline" 591 myconf="${myconf} --with-readline"
569 myconf="${myconf} --with-zlib-dir=/usr/" 592 myconf="${myconf} --with-zlib-dir=/usr/"
570 myconf="${myconf} --without-pstack" 593 myconf="${myconf} --without-pstack"
571 myconf="${myconf} --with-plugindir=/usr/$(get_libdir)/mysql/plugin" 594 myconf="${myconf} --with-plugindir=/usr/$(get_libdir)/mysql/plugin"
572 595
596 # This is an explict die here, because if we just forcibly disable it, then the
597 # user's data is not accessible.
598 use max-idx-128 && die "Bug #336027: upstream has a corruption issue with max-idx-128 presently"
573 use max-idx-128 && myconf="${myconf} --with-max-indexes=128" 599 #use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
574 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then 600 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
575 myconf="${myconf} $(use_enable community community-features)" 601 myconf="${myconf} $(use_enable community community-features)"
576 if use community; then 602 if use community; then
577 myconf="${myconf} $(use_enable profiling)" 603 myconf="${myconf} $(use_enable profiling)"
578 else 604 else
591 \) \ 617 \) \
592 -print0 \ 618 -print0 \
593 | xargs -0 sed -r -n \ 619 | xargs -0 sed -r -n \
594 -e '/^MYSQL_STORAGE_ENGINE/{ 620 -e '/^MYSQL_STORAGE_ENGINE/{
595 s~MYSQL_STORAGE_ENGINE\([[:space:]]*\[?([-_a-z0-9]+)\]?.*,~\1 ~g ; 621 s~MYSQL_STORAGE_ENGINE\([[:space:]]*\[?([-_a-z0-9]+)\]?.*,~\1 ~g ;
596 s~^([^ ]+).*~\1~gp; 622 s~^([^ ]+).*~\1~gp;
597 }' \ 623 }' \
598 | tr -s '\n' ' ' 624 | tr -s '\n' ' '
599 )" 625 )"
600 626
601 # 5.1 introduces a new way to manage storage engines (plugins) 627 # 5.1 introduces a new way to manage storage engines (plugins)
614 fi 640 fi
615 # Now the extras 641 # Now the extras
616 if use extraengine ; then 642 if use extraengine ; then
617 # like configuration=max-no-ndb, archive and example removed in 5.1.11 643 # like configuration=max-no-ndb, archive and example removed in 5.1.11
618 # not added yet: ibmdb2i 644 # not added yet: ibmdb2i
619 # Not supporting as examples: example,daemon_example,ftexample 645 # Not supporting as examples: example,daemon_example,ftexample
620 plugins_sta="${plugins_sta} partition" 646 plugins_sta="${plugins_sta} partition"
621 plugins_dyn="${plugins_sta} federated"
622 647
623 if [[ "${PN}" != "mariadb" ]] ; then 648 if [[ "${PN}" != "mariadb" ]] ; then
624 elog "Before using the Federated storage engine, please be sure to read" 649 elog "Before using the Federated storage engine, please be sure to read"
625 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 650 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
651 plugins_dyn="${plugins_sta} federated"
626 else 652 else
627 elog "MariaDB includes the FederatedX engine. Be sure to read" 653 elog "MariaDB includes the FederatedX engine. Be sure to read"
628 elog "http://askmonty.org/wiki/index.php/Manual:FederatedX_storage_engine" 654 elog "http://askmonty.org/wiki/index.php/Manual:FederatedX_storage_engine"
655 plugins_dyn="${plugins_sta} federatedx"
629 fi 656 fi
630 else 657 else
631 plugins_dis="${plugins_dis} partition federated" 658 plugins_dis="${plugins_dis} partition federated"
632 fi 659 fi
633 660
651 fi 678 fi
652 679
653 if [[ "${PN}" == "mariadb" ]] ; then 680 if [[ "${PN}" == "mariadb" ]] ; then
654 # In MariaDB, InnoDB is packaged in the xtradb directory, so it's not 681 # In MariaDB, InnoDB is packaged in the xtradb directory, so it's not
655 # caught above. 682 # caught above.
656 plugins_sta="${plugins_sta} maria innobase"
657 myconf="${myconf} $(use_with libevent)"
658 # This is not optional, without it several upstream testcases fail. 683 # This is not optional, without it several upstream testcases fail.
659 # Also strongly recommended by upstream. 684 # Also strongly recommended by upstream.
685 if [[ "${PV}" < "5.2.0" ]] ; then
660 myconf="${myconf} --with-maria-tmp-tables" 686 myconf="${myconf} --with-maria-tmp-tables"
687 plugins_sta="${plugins_sta} maria"
688 else
689 myconf="${myconf} --with-aria-tmp-tables"
690 plugins_sta="${plugins_sta} aria"
661 fi 691 fi
662 692
693 [ -e "${S}"/storage/innobase ] || [ -e "${S}"/storage/xtradb ] ||
694 die "The ${P} package doesn't provide innobase nor xtradb"
695
696 for i in innobase xtradb ; do
697 [ -e "${S}"/storage/${i} ] && plugins_sta="${plugins_sta} ${i}"
698 done
699
700 myconf="${myconf} $(use_with libevent)"
701
702 if mysql_version_is_at_least "5.2" ; then
703 #This should include sphinx, but the 5.2.4 archive forgot the plug.in file
704 #for i in oqgraph sphinx ; do
705 for i in oqgraph ; do
706 use ${i} \
707 && plugins_dyn="${plugins_dyn} ${i}" \
708 || plugins_dis="${plugins_dis} ${i}"
709 done
710 fi
711 fi
712
663 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]]; then 713 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]]; then
664 use pbxt \ 714 use pbxt \
665 && plugins_dyn="${plugins_dyn} pbxt" \ 715 && plugins_dyn="${plugins_dyn} pbxt" \
666 || plugins_dis="${plugins_dis} pbxt" 716 || plugins_dis="${plugins_dis} pbxt"
667 fi 717 fi
668 718
669 use static && \ 719 use static && \
670 plugins_sta="${plugins_sta} ${plugins_dyn}" && \ 720 plugins_sta="${plugins_sta} ${plugins_dyn}" && \
671 plugins_dyn="" 721 plugins_dyn=""
672 722
673 einfo "Available plugins: ${plugins_avail}" 723 einfo "Available plugins: ${plugins_avail}"
674 einfo "Dynamic plugins: ${plugins_dyn}" 724 einfo "Dynamic plugins: ${plugins_dyn}"
675 einfo "Static plugins: ${plugins_sta}" 725 einfo "Static plugins: ${plugins_sta}"
676 einfo "Disabled plugins: ${plugins_dis}" 726 einfo "Disabled plugins: ${plugins_dis}"
677 727
725# die if FEATURES="test", USE="-minimal" and not using FEATURES="userpriv" 775# die if FEATURES="test", USE="-minimal" and not using FEATURES="userpriv"
726# check for conflicting use flags 776# check for conflicting use flags
727# create new user and group for mysql 777# create new user and group for mysql
728# warn about deprecated features 778# warn about deprecated features
729mysql_pkg_setup() { 779mysql_pkg_setup() {
730 if hasq test ${FEATURES} ; then 780 if has test ${FEATURES} ; then
731 if ! use minimal ; then 781 if ! use minimal ; then
732 if [[ $UID -eq 0 ]]; then 782 if [[ $UID -eq 0 ]]; then
733 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root." 783 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root."
734 fi 784 fi
735 fi 785 fi
736 fi 786 fi
787
788 # bug 350844
789 case "${EAPI:-0}" in
790 0 | 1)
791 if use static && !built_with_use sys-libs/ncurses static-libs; then
792 die "To build MySQL statically you need to enable static-libs for sys-libs/ncurses"
793 fi
794 ;;
795 esac
737 796
738 # Check for USE flag problems in pkg_setup 797 # Check for USE flag problems in pkg_setup
739 if use static && use ssl ; then 798 if use static && use ssl ; then
740 M="MySQL does not support being built statically with SSL support enabled!" 799 M="MySQL does not support being built statically with SSL support enabled!"
741 eerror "${M}" 800 eerror "${M}"
742 die "${M}" 801 die "${M}"
802 fi
803
804 if mysql_version_is_at_least "5.1.51" \
805 && ! mysql_version_is_at_least "5.2" \
806 && use debug ; then
807 # Also in package.use.mask
808 die "Bug #344885: Upstream has broken USE=debug for 5.1 series >=5.1.51"
743 fi 809 fi
744 810
745 if ! mysql_version_is_at_least "5.0" \ 811 if ! mysql_version_is_at_least "5.0" \
746 && use raid \ 812 && use raid \
747 && use static ; then 813 && use static ; then
755 && use minimal ; then 821 && use minimal ; then
756 M="USE flags 'cluster', 'extraengine', 'embedded' conflict with 'minimal' USE flag!" 822 M="USE flags 'cluster', 'extraengine', 'embedded' conflict with 'minimal' USE flag!"
757 eerror "${M}" 823 eerror "${M}"
758 die "${M}" 824 die "${M}"
759 fi 825 fi
760 826
761 if mysql_version_is_at_least "5.1" \ 827 if mysql_version_is_at_least "5.1" \
762 && xtradb_patch_available \ 828 && xtradb_patch_available \
763 && use xtradb \ 829 && use xtradb \
764 && use embedded ; then 830 && use embedded ; then
765 M="USE flags 'xtradb' and 'embedded' conflict and cause build failures" 831 M="USE flags 'xtradb' and 'embedded' conflict and cause build failures"
771 # Upstream changes made us need a fairly new GCC4. 837 # Upstream changes made us need a fairly new GCC4.
772 # But only for 5.0.8[3-6]! 838 # But only for 5.0.8[3-6]!
773 if mysql_version_is_at_least "5.0.83" && ! mysql_version_is_at_least 5.0.87 ; then 839 if mysql_version_is_at_least "5.0.83" && ! mysql_version_is_at_least 5.0.87 ; then
774 GCC_VER=$(gcc-version) 840 GCC_VER=$(gcc-version)
775 case ${GCC_VER} in 841 case ${GCC_VER} in
776 2*|3*|4.0|4.1|4.2) 842 2*|3*|4.0|4.1|4.2)
777 eerror "Some releases of MySQL required a very new GCC, and then" 843 eerror "Some releases of MySQL required a very new GCC, and then"
778 eerror "later release relaxed that requirement again. Either pick a" 844 eerror "later release relaxed that requirement again. Either pick a"
779 eerror "MySQL >=5.0.87, or use a newer GCC." 845 eerror "MySQL >=5.0.87, or use a newer GCC."
780 die "Active GCC too old!" ;; 846 die "Active GCC too old!" ;;
781 esac 847 esac
835 mysql_mv_patches 901 mysql_mv_patches
836 # And apply 902 # And apply
837 epatch 903 epatch
838 904
839 # last -fPIC fixup, per bug #305873 905 # last -fPIC fixup, per bug #305873
840 i="${S}"/storage/innodb_plugin/plug.in 906 i="${S}"/storage/innodb_plugin/plug.in
841 [ -f "${i}" ] && sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}" 907 [ -f "${i}" ] && sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}"
842 908
843 # Additional checks, remove bundled zlib (Cluster needs this, for static 909 # Additional checks, remove bundled zlib (Cluster needs this, for static
844 # memory management in zlib, leave available for Cluster) 910 # memory management in zlib, leave available for Cluster)
845 if [[ "${PN}" != "mysql-cluster" ]] ; then 911 if [[ "${PN}" != "mysql-cluster" ]] ; then
875 # Or maybe we haven't 941 # Or maybe we haven't
876 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}" 942 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}"
877 cp -ral "${WORKDIR}/${XTRADB_P}" "${i}" 943 cp -ral "${WORKDIR}/${XTRADB_P}" "${i}"
878 popd >/dev/null 944 popd >/dev/null
879 fi 945 fi
880 946
881 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]] && use pbxt ; then 947 if pbxt_patch_available && [[ "${PBXT_NEWSTYLE}" == "1" ]] && use pbxt ; then
882 einfo "Adding storage engine: PBXT" 948 einfo "Adding storage engine: PBXT"
883 pushd "${S}"/storage >/dev/null 949 pushd "${S}"/storage >/dev/null
884 i='pbxt' 950 i='pbxt'
885 [ -d "${i}" ] && rm -rf "${i}" 951 [ -d "${i}" ] && rm -rf "${i}"
886 cp -ral "${WORKDIR}/${PBXT_P}" "${i}" 952 cp -ral "${WORKDIR}/${PBXT_P}" "${i}"
967 export CXXFLAGS 1033 export CXXFLAGS
968 1034
969 # bug #283926, with GCC4.4, this is required to get correct behavior. 1035 # bug #283926, with GCC4.4, this is required to get correct behavior.
970 append-flags -fno-strict-aliasing 1036 append-flags -fno-strict-aliasing
971 1037
1038 # bug #335185, #335995, with >= GCC4.3.3 on x86 only, omit-frame-pointer
1039 # causes a mis-compile.
1040 # Upstream bugs:
1041 # http://gcc.gnu.org/bugzilla/show_bug.cgi?id=38562
1042 # http://bugs.mysql.com/bug.php?id=45205
1043 use x86 && version_is_at_least "4.3.3" "$(gcc-fullversion)" && \
1044 append-flags -fno-omit-frame-pointer && \
1045 filter-flags -fomit-frame-pointer
1046
972 econf \ 1047 econf \
973 --libexecdir="/usr/sbin" \ 1048 --libexecdir="/usr/sbin" \
974 --sysconfdir="${MY_SYSCONFDIR}" \ 1049 --sysconfdir="${MY_SYSCONFDIR}" \
975 --localstatedir="${MY_LOCALSTATEDIR}" \ 1050 --localstatedir="${MY_LOCALSTATEDIR}" \
976 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 1051 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
979 --with-low-memory \ 1054 --with-low-memory \
980 --with-client-ldflags=-lstdc++ \ 1055 --with-client-ldflags=-lstdc++ \
981 --enable-thread-safe-client \ 1056 --enable-thread-safe-client \
982 --with-comment="Gentoo Linux ${PF}" \ 1057 --with-comment="Gentoo Linux ${PF}" \
983 --without-docs \ 1058 --without-docs \
1059 --with-LIBDIR="$(get_libdir)" \
984 ${myconf} || die "econf failed" 1060 ${myconf} || die "econf failed"
985 1061
986 # TODO: Move this before autoreconf !!! 1062 # TODO: Move this before autoreconf !!!
987 find . -type f -name Makefile -print0 \ 1063 find . -type f -name Makefile -print0 \
988 | xargs -0 -n100 sed -i \ 1064 | xargs -0 -n100 sed -i \
1057 if use !test ; then 1133 if use !test ; then
1058 rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test 1134 rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test
1059 fi 1135 fi
1060 1136
1061 # Configuration stuff 1137 # Configuration stuff
1062 if mysql_version_is_at_least "5.1" ; then 1138 case ${MYSQL_PV_MAJOR} in
1063 mysql_mycnf_version="5.1"
1064 elif mysql_version_is_at_least "4.1" ; then
1065 mysql_mycnf_version="4.1"
1066 else
1067 mysql_mycnf_version="4.0" 1139 3*|4.0) mysql_mycnf_version="4.0" ;;
1068 fi 1140 4.[1-9]|5.0) mysql_mycnf_version="4.1" ;;
1069 einfo "Building default my.cnf" 1141 5.[1-9]|6*|7*) mysql_mycnf_version="5.1" ;;
1142 esac
1143 einfo "Building default my.cnf (${mysql_mycnf_version})"
1070 insinto "${MY_SYSCONFDIR}" 1144 insinto "${MY_SYSCONFDIR}"
1071 doins scripts/mysqlaccess.conf 1145 doins scripts/mysqlaccess.conf
1146 mycnf_src="my.cnf-${mysql_mycnf_version}"
1072 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \ 1147 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
1073 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 1148 "${FILESDIR}/${mycnf_src}" \
1074 > "${TMPDIR}/my.cnf.ok" 1149 > "${TMPDIR}/my.cnf.ok"
1075 if mysql_version_is_at_least "4.1" && use latin1 ; then 1150 if use latin1 ; then
1076 sed -i \ 1151 sed -i \
1077 -e "/character-set/s|utf8|latin1|g" \ 1152 -e "/character-set/s|utf8|latin1|g" \
1078 "${TMPDIR}/my.cnf.ok" 1153 "${TMPDIR}/my.cnf.ok"
1079 fi 1154 fi
1080 newins "${TMPDIR}/my.cnf.ok" my.cnf 1155 newins "${TMPDIR}/my.cnf.ok" my.cnf
1098 done 1173 done
1099 fi 1174 fi
1100 1175
1101 # Docs 1176 # Docs
1102 einfo "Installing docs" 1177 einfo "Installing docs"
1103 dodoc README ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 1178 for i in README ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE ; do
1179 [[ -f "$i" ]] && dodoc "$i"
1180 done
1104 doinfo "${S}"/Docs/mysql.info 1181 doinfo "${S}"/Docs/mysql.info
1105 1182
1106 # Minimal builds don't have the MySQL server 1183 # Minimal builds don't have the MySQL server
1107 if ! use minimal ; then 1184 if ! use minimal ; then
1108 einfo "Including support files and sample configurations" 1185 einfo "Including support files and sample configurations"
1174 1251
1175 einfo 1252 einfo
1176 elog "You might want to run:" 1253 elog "You might want to run:"
1177 elog "\"emerge --config =${CATEGORY}/${PF}\"" 1254 elog "\"emerge --config =${CATEGORY}/${PF}\""
1178 elog "if this is a new install." 1255 elog "if this is a new install."
1256 einfo
1257
1258 einfo
1259 elog "If you are upgrading major versions, you should run the"
1260 elog "mysql_upgrade tool."
1179 einfo 1261 einfo
1180 fi 1262 fi
1181 1263
1182 if pbxt_available && use pbxt ; then 1264 if pbxt_available && use pbxt ; then
1183 # TODO: explain it better 1265 # TODO: explain it better
1238 fi 1320 fi
1239 fi 1321 fi
1240 1322
1241 local pwd1="a" 1323 local pwd1="a"
1242 local pwd2="b" 1324 local pwd2="b"
1243 local MYSQL_ROOT_PASSWORD=''
1244 local maxtry=15 1325 local maxtry=15
1245 1326
1246 if [ -z "${MYSQL_ROOT_PASSWORD}" -a -f "${ROOT}/root/.my.cnf" ]; then 1327 if [ -z "${MYSQL_ROOT_PASSWORD}" -a -f "${ROOT}/root/.my.cnf" ]; then
1247 MYSQL_ROOT_PASSWORD="$(sed -n -e '/^password=/s,^password=,,gp' "${ROOT}/root/.my.cnf")" 1328 MYSQL_ROOT_PASSWORD="$(sed -n -e '/^password=/s,^password=,,gp' "${ROOT}/root/.my.cnf")"
1248 fi 1329 fi
1258 # localhost. Also causes weird failures. 1339 # localhost. Also causes weird failures.
1259 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost" 1340 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost"
1260 1341
1261 if [ -z "${MYSQL_ROOT_PASSWORD}" ]; then 1342 if [ -z "${MYSQL_ROOT_PASSWORD}" ]; then
1262 1343
1263 einfo "Please provide a password for the mysql 'root' user now," 1344 einfo "Please provide a password for the mysql 'root' user now, in the"
1264 einfo "or in the MYSQL_ROOT_PASSWORD env var." 1345 einfo "MYSQL_ROOT_PASSWORD env var or through the /root/.my.cnf file."
1265 ewarn "Avoid [\"'\\_%] characters in the password" 1346 ewarn "Avoid [\"'\\_%] characters in the password"
1266 read -rsp " >" pwd1 ; echo 1347 read -rsp " >" pwd1 ; echo
1267 1348
1268 einfo "Retype the password" 1349 einfo "Retype the password"
1269 read -rsp " >" pwd2 ; echo 1350 read -rsp " >" pwd2 ; echo
1317 1398
1318 if [[ -r "${help_tables}" ]] ; then 1399 if [[ -r "${help_tables}" ]] ; then
1319 cat "${help_tables}" >> "${sqltmp}" 1400 cat "${help_tables}" >> "${sqltmp}"
1320 fi 1401 fi
1321 fi 1402 fi
1322 1403
1323 einfo "Creating the mysql database and setting proper" 1404 einfo "Creating the mysql database and setting proper"
1324 einfo "permissions on it ..." 1405 einfo "permissions on it ..."
1325 1406
1326 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock" 1407 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock"
1327 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid" 1408 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid"

Legend:
Removed from v.1.150  
changed lines
  Added in v.1.165

  ViewVC Help
Powered by ViewVC 1.1.20